<?php
require_once('wp-plugin-retina.php');

//debug
//trigger_error(">".print_r($variable, true).";<", E_USER_ERROR);
//$aa=var_dump(func_get_args(),true);

if (!class_exists('wp_retina')) {
    class wp_retina extends WPPlugin_retina {
        private $saved_error;
        private $options_default;
		private $RetinaPost;
        
        // php 4 constructor
        function wp_retina($options_name) {
            $args = func_get_args();
            call_user_func_array(array(&$this, "__construct"), $args);
        }
        // php 5 constructor
        function __construct($options_name) {
            parent::__construct($options_name);
					
			$this->options_default= array('public_key'=>'', 'private_key'=>'','call_to_action'=>'Type the colored letters','incorrect_response_error'=>'Incorrect response.', 'readmore_show' =>1, 'readmore_message'=>'Post & Read More', 'show_in_comments'=>1,'bypass_for_registered_users'=>0,'minimum_bypass_level'=>'read','type_c'=>'feed','feed_URL_c'=>'','feed_limit_c'=>10,'custom_title_c'=>'','custom_description_c'=>'','custom_link_c'=>'','show_in_registration'=>0,'type_r'=>'feed','feed_URL_r'=>'','feed_limit_r'=>10,'custom_title_r'=>'','custom_description_r'=>'','custom_link_r'=>'','xhtml_compliance'=>0,'tab_index_c'=>'','tab_index_r'=>21);
			
			// create RetinaPost object 
			require_once($this->path_to_plugin_directory() . '/Retina_Library.php');
			$this->RetinaPost = new RetinaPost();
            
            // register the hooks
            $this->register_actions_filters();
        }
        
		//-------------------------------------------------------------------
        function register_actions_filters() {
            
			// load the plugin's textdomain for localization
            /*dd retina doesn't have languages yet*/ // add_action('init', array(&$this, 'load_textdomain'));
        
             // options  // run when the plugin is activated
            register_activation_hook(WPPlugin_retina::path_to_plugin_directory() . '/retina-post.php', array(&$this, 'activation_load_options')); 
            add_action('admin_init', array(&$this, 'register_settings_group'));
			
			// only register the hooks if the user wants retina on the comments page
            if ($this->options['show_in_comments']) {
                add_action('comment_form', array(&$this, 'show_in_comments'));
                // retina comment processing (look into doing all of this with AJAX, optionally)				
				add_action('preprocess_comment', array(&$this, 'check_comment'), 0);
				add_action('comment_post_redirect', array(&$this, 'relative_redirect'), 0, 2);
				add_filter( 'comment_form_default_fields', array(&$this, 'fill_saved_default_fields') );
                add_filter( 'comment_form_field_comment', array(&$this, 'fill_saved_comment'));				
            }
            // only register the hooks if the user wants retina on the registration page
            if ($this->options['show_in_registration']) {
                if ($this->is_multi_blog()){
                    add_action('signup_extra_fields', array(&$this, 'show_in_registration'));    // retina form display
					add_filter('wpmu_validate_user_signup', array(&$this, 'check_registration_wpmu'));  // retina check
                }else{
                    add_action('register_form', array(&$this, 'show_in_registration'));
					add_filter('registration_errors', array(&$this, 'check_registration'));
				}
            }
			
			// load jQuery when using Read More button
			if ( $this->options['readmore_show']) {
				// For use on the Front end (ie. Theme)
				add_action('wp_enqueue_scripts', array(&$this, 'enqueue_aditional_plugins'));
			}

            // administration (menus, pages, notifications, etc.)
            add_filter("plugin_action_links", array(&$this, 'show_settings_link'), 10, 2);
            add_action('admin_menu', array(&$this, 'add_settings_page'));
            
            // admin notices
            add_action('admin_notices', array(&$this, 'show_admin_notice'));
        }
		
		function enqueue_aditional_plugins() {
			wp_enqueue_script( 'jquery' );
		}
		
		//-------------------------------------------------------------------
        function activation_load_options() {
			$old_options = WPPlugin_retina::retrieve_options($this->options_name);
			if ($old_options) {
				$options = $this->options_default;     // pre-load with the default options
				foreach($old_options as $key => $val) // the old options will replace default options
					$options[$key] = $val;
					
				if (empty($old_options['readmore_show'])) $options['readmore_show'] = 0;
					
				// Compute the type for old vesrions
				if (empty($old_options['type_c'])) $options['type_c'] = (!empty($options['custom_title_c']) && !empty($options['custom_description_c']))? 'text':'feed';
				if (empty($old_options['type_r'])) $options['type_r'] = (!empty($options['custom_title_r']) && !empty($options['custom_description_r']))? 'text':'feed';						
			}           
            else {			
			   // here get_bloginfo is available
               $this->options_default['feed_URL_c']= get_bloginfo('rss2_url');
               $this->options_default['feed_URL_r']= get_bloginfo('rss2_url');
			   
               $options= $this->options_default;			   
            }			            
            WPPlugin_retina::remove_options($this->options_name);            
            WPPlugin_retina::add_options($this->options_name, $options);            
        }
		
        //-------------------------------------------------------------------
        function register_settings_group() {
            register_setting("retinapost_options_group", 'retinapost_options', array(&$this, 'validate_options'));
        }
				function validate_dropdown($array, $key, $value) {
					// make sure that the capability that was supplied is a valid capability from the drop-down list
					if (in_array($value, $array))
						return $value;
					else // if not, load the old value
						return $this->options[$key];
				}        
			function validate_options($options) {
				function trim_arr(&$value) { $value = trim($value);}
				array_walk($options, 'trim_arr');
				
				$options['call_to_action'] = !empty($options['call_to_action'])?$options['call_to_action']:$this->options_default['call_to_action'];
				$options['incorrect_response_error'] = !empty($options['incorrect_response_error'])?$options['incorrect_response_error']:$this->options_default['incorrect_response_error'];

				$options['readmore_message'] = !empty($options['readmore_message'])?$options['readmore_message']:$this->options_default['readmore_message'];
				
				$options['show_in_comments'] = (isset($options['show_in_comments']) && intval($options['show_in_comments'])==1) ? 1: 0;
				$options['bypass_for_registered_users'] = (isset($options['bypass_for_registered_users']) && intval($options['bypass_for_registered_users'])== 1) ? 1: 0;
				$capabilities = array ('read', 'edit_posts', 'publish_posts', 'moderate_comments', 'activate_plugins');      
				$options['minimum_bypass_level'] = $this->validate_dropdown($capabilities, 'minimum_bypass_level', $options['minimum_bypass_level']);			                        
				$options['feed_limit_c'] = 	(intval($options['feed_limit_c'])>0&&intval($options['feed_limit_c'])<100) ? intval($options["feed_limit_c"]) : 10;
				$tab_index_c = intval($options['tab_index_c']);
				$options['tab_index_c'] = ( $tab_index_c>0 && $tab_index_c<9999)? $tab_index_c : $this->options_default['tab_index_c'];
				$options['show_in_registration'] = (isset($options['show_in_registration']) && intval($options['show_in_registration'])==1) ? 1: 0;
				$options['feed_limit_r'] = 	(intval($options['feed_limit_r'])>0&&intval($options['feed_limit_r'])<100) ? intval($options["feed_limit_r"]) : 10;			
				$tab_index_r = intval($options['tab_index_r']);
				$options['tab_index_r'] = ( $tab_index_r>0 && $tab_index_r<9999)? $tab_index_r : $this->options_default['tab_index_r'];
				$options['xhtml_compliance'] = (isset($options['xhtml_compliance']) && intval($options['xhtml_compliance'])==1) ? 1: 0;
		
				return $options;
			}		
		
		//-------------------------------------------------------------------
			function retina_enabled() {
				return ($this->options['show_in_comments'] || $this->options['show_in_registration']);
			}                    
			function keys_missing() {
				return (empty($this->options['public_key']) || empty($this->options['private_key']));
			}
		
        function show_admin_notice() {
			$have_error= false;			
            if (!$have_error && $this->retina_enabled() && (empty($this->options['public_key']) || empty($this->options['private_key']))) {                
				$have_error= true;
            }
            if (!$have_error && $this->options['show_in_comments'] && $this->options['type_c']=='feed' && empty($this->options['feed_URL_c'])) {	                
				$have_error= true;
            }
            if (!$have_error && $this->options['show_in_comments'] && $this->options['type_c']=='text' && (empty($this->options['custom_title_c'])||empty($this->options['custom_description_c']))) {
				$have_error= true;
            }
            if (!$have_error && $this->options['show_in_registration'] && $this->options['type_r']=='feed' && empty($this->options['feed_URL_r'])) {	
				$have_error= true;
            }
            if (!$have_error && $this->options['show_in_registration'] && $this->options['type_r']=='text' && (empty($this->options['custom_title_r'])||empty($this->options['custom_description_r']))) {                
				$have_error= true;
            }
            if ($have_error && FALSE===strpos($_SERVER['REQUEST_URI'], 'retina-post')) {                
				$options_url = admin_url('options-general.php?page=retina-post/wp-retina.php');
				$message = sprintf(__('Configure Retina Post ' . ' <a href="%s" title="Retina Settings"> Go to settings</a>', 'retinapost'), $options_url);            
				echo '<div class="notice" style="color:#ffC050"><p><strong>'.$message . '</strong></p></div>';
            }
        }
        //-------------------------------------------------------------------
        function show_in_registration($errors) {
            // if it's for wordpress mu, show the errors
            if ($this->is_multi_blog()) {
                $error = $errors->get_error_message('captcha');
                echo '<label for="verification">Verification:</label>';
                echo ($error ? '<p class="error">'.$error.'</p>' : '');
                echo $this->get_retina_html($this->options['call_to_action'],'r');
            }            
            // for regular wordpress
            else {
                echo $this->get_retina_html($this->options['call_to_action'],'r');
            }
        }
        
        function check_registration($errors) {
            // empty so throw the empty response error
					
            if (empty($_POST['Retina_response']) || trim($_POST['Retina_response'])=='') {
                $errors->add('blank_captcha', $this->options['incorrect_response_error']);
				return $errors;
            }
			
			$this->RetinaPost->privateKey = $this->options['private_key'];
            if (!$debug=$this->RetinaPost->check())
                $errors->add('captcha_wrong', $this->options['incorrect_response_error']);			
				return $errors;
        }
        
        function check_registration_wpmu($result) {
            // must make a check here, otherwise the wp-admin/user-new.php script will keep trying to call
            // this function despite not having called do_action('signup_extra_fields'), so the retina
            // field was never shown. this way it won't validate if it's called in the admin interface
            
            if (!$this->is_authority()) {
                // no text entered
                if (empty($_POST['Retina_response']) || trim($_POST['Retina_response'])=='') {
                    $result['errors']->add('blank_captcha', $this->options['incorrect_response_error']);
                    return $result;
                }
                
				$this->RetinaPost->privateKey = $this->options['private_key'];				
                // todo: why echo the error here? wpmu specific?
                if (!$this->RetinaPost->check()){
                    $result['errors']->add('captcha_wrong', $this->options['incorrect_response_error']);
                    //echo '<div class="error">' . $this->options['incorrect_response_error'] . '</div>';
                }                    
                return $result;
            }
        }
        
        function get_retina_html($retina_message, $were, $use_ssl=false) {
			$this->RetinaPost->publicKey = $this->options['public_key'];
							
            if ($this->options['type_'.$were]=='feed')
				return $this->RetinaPost->get(array("model"=>"feed", "feed_URL"=>$this->options['feed_URL_'.$were], "feed_remove"=>get_the_title(), "feed_limit"=>$this->options['feed_limit_'.$were], "message"=>$retina_message, "tab_index"=>$this->options['tab_index_'.$were], "xhtml_strict"=>$this->options['xhtml_compliance']));
			else 
				return $this->RetinaPost->get(array("model"=>"text", "title"=>$this->options['custom_title_'.$were], "description"=>$this->options['custom_description_'.$were], "link"=>$this->options['custom_link_'.$were], "message"=>$retina_message, "tab_index"=>$this->options['tab_index_'.$were], "xhtml_strict"=>$this->options['xhtml_compliance']));
        }
        
		//-------------------------------------------------------------------
        function show_in_comments() {
            global $user_ID;

            // set the minimum capability needed to skip the captcha if there is one
            if (isset($this->options['bypass_for_registered_users']) && $this->options['bypass_for_registered_users'] && $this->options['minimum_bypass_level'])
                $needed_capability = $this->options['minimum_bypass_level'];

            // skip the retina display if the minimum capability is met
            if ((isset($needed_capability) && $needed_capability && current_user_can($needed_capability)) || !$this->options['show_in_comments'])
                return;

            else {
                // SHOW ERROR MESSAGE if there is an error
                if (!empty($_GET['retina_error']))
                    echo '<p class="none" style="color:#ff3333;">' .$this->options['incorrect_response_error'] . "</p>";

                // todo: replace this with jquery: http://digwp.com/2009/06/including-jquery-in-wordpress-the-right-way/
              	ob_start(); ?>				
					<div id="retina-submit-btn-area">&nbsp;</div>
				<?php if (!$this->options['xhtml_compliance']){ ?>
                    <noscript>
                         <style type='text/css'>#submit {display:none;}</style>
                         <input name="submit" type="submit" id="submit-alt" value="Submit Comment"/> 
                    </noscript>
				<?php } ?>	
					<script type="text/javascript">	
					var submite_button = document.getElementById('submit');	
					submite_button.tabIndex = document.getElementById('Retina_edit_0').tabIndex;
					document.getElementById('retina-submit-btn-area').appendChild (submite_button);
					
				<?php if ($this->options['readmore_show']) {	?>
				var retina_link = document.getElementById('Retina_link');
				if ( retina_link && retina_link.href!='')
				{
					jQuery.fn.copyCSS = function(source){
					var dom = jQuery(source).get(0);
					var style;
					var dest = {};
					if(window.getComputedStyle){
						var camelize = function(a,b){
							return b.toUpperCase();
						};
						style = window.getComputedStyle(dom, null);
						for(var i = 0, l = style.length; i < l; i++){
							var prop = style[i];
							var camel = prop.replace(/\-([a-z])/g, camelize);
							var val = style.getPropertyValue(prop);
							dest[camel] = val;
						};
						return this.css(dest);
					};
					if(style = dom.currentStyle){
						for(var prop in style){
							dest[prop] = style[prop];
						};
						return this.css(dest);
				   };
				   if(style = dom.style){
					  for(var prop in style){
						if(typeof style[prop] != 'function'){
						  dest[prop] = style[prop];
						};
					  };
					};
					return this.css(dest);
					};
				
					var readmore_button = document.createElement('button');
					readmore_button.setAttribute('type','submit');
					readmore_button.setAttribute('value','Submit & Read More');
					readmore_button.innerHTML= '<?php echo $this->options['readmore_message']; ?> <img style="border:0;padding:0 0 0 10px;margin:0;vertical-align:middle" src="<?php echo plugins_url( 'link.png' , __FILE__ ); ?>">';
					readmore_button.onclick = function(){
						redirect_input = document.createElement('input');
						redirect_input.setAttribute('type','hidden');
						redirect_input.setAttribute('name','retina_redirect_input');
						redirect_input.value = retina_link.href;
						document.getElementById('retina-submit-btn-area').appendChild(redirect_input);
					}
					
					readmore_button.setAttribute('tabIndex',submite_button.tabIndex);
					readmore_button.id='readmore_button';
					
					// Some default style
					readmore_button.style.backgroundColor="#EEEEEE";
					readmore_button.style.border="none";
					readmore_button.style.borderRadius="5px";
					readmore_button.style.color="#333333";
					readmore_button.style.cssFloat="right";
					readmore_button.style.marginRight="100px";
					readmore_button.style.cursor="pointer";
					
					jQuery(readmore_button).copyCSS('#submit');					
					readmore_button.style.marginBottom= '0px';
					readmore_button.style.width= 'auto';
					readmore_button.style.height= 'auto';
					readmore_button.style.maxHeight= 'none';
					readmore_button.style.maxWidth= 'none';
					readmore_button.style.display= 'block';					 
					submite_button.style.fontSize = (parseInt(readmore_button.style.fontSize, 10)-2)+'px';
									
					document.getElementById('retina-submit-btn-area').insertBefore(readmore_button, submite_button);
				}
				<?php } ?>											
                </script> 
				<?php $reorder_submit_button.= ob_get_clean();
				
                echo $this->get_retina_html($this->options['call_to_action'], 'c') . $reorder_submit_button;
           }
        } 
          
        function check_comment($comment_data) {
            global $user_ID;
            
            if ($this->options['bypass_for_registered_users'] && $this->options['minimum_bypass_level'])
                $needed_capability = $this->options['minimum_bypass_level'];
            
            if ((isset($needed_capability) && current_user_can($needed_capability)) || !$this->options['show_in_comments'])
                return $comment_data;
            
			// do not check trackbacks/pingbacks
			if ($comment_data['comment_type'] == '') {
					
				$this->RetinaPost->privateKey = $this->options['private_key'];
				if ($this->RetinaPost->check())
					return $comment_data;
					
				else {
					$this->saved_error = $this->RetinaPost->get_error();										
					// http://codex.wordpress.org/Plugin_API/Filter_Reference#Database_Writes_2
					add_filter('pre_comment_approved', create_function('$a', 'return \'trash\';'));					
					return $comment_data;
				}
			}		     
            return $comment_data;
        }
        
        function relative_redirect($location, $comment) {
            if ($this->saved_error != '') {
                // replace #comment- at the end of $location with #commentform                
                $location = substr($location, 0, strpos($location, '#')) .
                    ((strpos($location, "?") === false) ? "?" : "&") .
					http_build_query(array('retina_error'=>$this->saved_error, 'retina_comment_id'=> $comment->comment_ID)).
                    '#commentform';
            }
			else if (!empty( $_POST["retina_redirect_input"] )) $location = $_POST["retina_redirect_input"];
            return $location;
        }

		function fill_saved_default_fields( $fields ) {
			if (!empty($_GET['retina_comment_id'])){			
				$comment = get_comment($_GET['retina_comment_id']);
				
				$fields["author"] 	= str_replace( 'value=""', 'value="'.$comment->comment_author		.'"', 	$fields["author"] );
				$fields["email"] 	= str_replace( 'value=""', 'value="'.$comment->comment_author_email .'"', 	$fields["email"] );			
				$fields["url"] 		= str_replace( 'value=""', 'value="'.$comment->comment_author_url	.'"', 	$fields["url"] );			
			}
			return $fields;
		}			

		function fill_saved_comment( $field ) {	
			if (!empty($_GET['retina_comment_id'])){
				$comment = get_comment($_GET['retina_comment_id']);
				$field = str_replace( '</textarea>', $comment->comment_content.'</textarea>', $field );			
				wp_delete_comment($comment->comment_ID);
			}
			return $field;
		}
	
        //-------------------------------------------------------------------
        // add a settings link to the plugin in the plugin list
        function show_settings_link($links, $file){
			if (basename($file) == 'retina-post.php') {
               $settings_title = __('Settings for RetinaPost', 'retinapost');
               $settings = __('Settings', 'retinapost');
               $settings_link = '<a href="options-general.php?page=retina-post/wp-retina.php" title="' . $settings_title . '">' . $settings . '</a>';
               array_unshift($links, $settings_link);
            }            
            return $links;
        }
        
		//-------------------------------------------------------------------
        // add the settings page
        function add_settings_page() {
            // add the options page
            if ($this->environment == Environment::WordPressMU && $this->is_authority())
                add_submenu_page('wpmu-admin.php', 'Retina Post', 'Retina Post', 'manage_options', __FILE__, array(&$this, 'show_settings_page'));

            if ($this->environment == Environment::WordPressMS && $this->is_authority())
                add_submenu_page('ms-admin.php', 'Retina Post', 'Retina Post', 'manage_options', __FILE__, array(&$this, 'show_settings_page'));
            
            add_options_page('Engage user & fight spam', 'Engage & Antispam<br/> &nbsp;&nbsp;&nbsp; by RetinaPost', 'manage_options', __FILE__, array(&$this, 'show_settings_page'));
        }        
			// store the xhtml in a separate file and use include on it
			function show_settings_page() {
				include("settings.php");
			}
        		
		//-------------------------------------------------------------------
        function build_dropdown($name, $keyvalue, $checked_value) {
            echo '<select name="' . $name . '" id="' . $name . '">' . "\n";
            
            foreach ($keyvalue as $key => $value) {
                $checked = ($value == $checked_value) ? ' selected="selected" ' : '';
                
                echo '\t <option value="' . $value . '"' . $checked . ">$key</option> \n";
                $checked = NULL;
            }
            
            echo "</select> \n";
        }
        
        function capabilities_dropdown() {
            // define choices: Display text => permission slug
            $capabilities = array (
                __('all registered users', 'retinapost') => 'read',
                __('edit posts', 'retinapost') => 'edit_posts',
                __('publish posts', 'retinapost') => 'publish_posts',
                __('moderate comments', 'retinapost') => 'moderate_comments',
                __('activate plugins', 'retinapost') => 'activate_plugins'
            );
            
            $this->build_dropdown('retinapost_options[minimum_bypass_level]', $capabilities, $this->options['minimum_bypass_level']);
        }

		function error_feed_c(){		
			return ( $this->options['show_in_comments'] && $this->options['type_c']=='feed' && empty($this->options['feed_URL_c']));
		}		
		function error_comment_c(){		
			return ( $this->options['show_in_comments'] && $this->options['type_c']=='text' && (empty($this->options['custom_title_c']) || empty($this->options['custom_description_c'])));
		}
		function error_feed_r(){		
			return ( $this->options['show_in_registration'] && $this->options['type_r']=='feed' && empty($this->options['feed_URL_r']));
		}
		function error_comment_r(){		
			return ( $this->options['show_in_registration'] && $this->options['type_r']=='text' && (empty($this->options['custom_title_r']) || empty($this->options['custom_description_r'])));
		}
		
		function get_domain(){
			$domain = parse_url(get_site_url(),PHP_URL_HOST);
			$domain = str_replace(array('https','http','www.','://',':/'), '', $domain);
			$domain = explode('/', $domain); 
			$domain = $domain[0];
			$domain = explode(':', $domain);
			return (strpos($domain[0],'localhost')===FALSE)?$domain[0]:get_bloginfo('admin_email');
		}
		
		function generate_private_key($email) {
			$rand_pos = mt_rand(0,strlen($email)-1);
			$stuffed_key = mt_rand(0,999999).substr($email, 0, $rand_pos).mt_rand().substr($email, $rand_pos);		
			return hash('tiger192,4', $stuffed_key );		
		}

    } // end class declaration
} // end of class exists clause

?>